# com.fr.plugin.platform.db.transfer.dm

达梦数据库外置数据库迁移

# 需求编号
	JSD-7366 平台数据迁移数据库支持达梦数据库
	
# 插件说明
    plugin-dm-platform-transfer.jar 以及 达梦连接驱动包(达梦7测试用的 Dm7JdbcDriver18.jar) 拷贝到 lib 目录下；
    插件包正常安装即可。
    
# 实现逻辑
    plugin-dm-platform-transfer.jar 中 FRDMDialect 继承 com.fr.third.org.hibernate.dialect
    (https://repo1.maven.org/maven2/com/dameng/DmDialect-for-hibernate5.3/7.6.0.165/ 不同版本达梦 DmDialect 还不一定兼容) 
    DmDialect已知问题：
    1、varchar 和 varbinary 字段不支持超过 8188
    2、达梦数据库迁移报错 Violate not null constraint on [DEPARTMENTID]
        DEPARTMENTID 字段是 not null, finedb中数据是空字符串，但是在迁移的过程报错不允许为空约束，这是因为达梦数据库 COMPATIBLE 参数可以修改配置（Server compatible mode, 0:none, 1:SQL92, 2:Oracle, 3:MS SQL Server, 4:MySQL, 5:DM6, 6:Teradata ,可通过 SELECT * FROM v$DM_INI  WHERE PARA_NAME = 'COMPATIBLE_MODE' 查询），当值为 2的时候表示是识别为 oracle 模式，会出现上诉问题，
        修改方案：在数据库安装目录下找到 dm.ini 文件修改其中的 COMPATIBLE 值为 0(其他值未验证)，重启数据库。
