!(function () {
    try {
        BI.Providers.getProvider("dec.provider.migration");
        // 20.08.31 以及版本
        BI.config('dec.provider.migration', provider => {
            provider.registerDatabase({
                value: 'dm',
                driver: ['dm.jdbc.driver.DmDriver'],
                url: 'jdbc:dm://{host}:{port}/{database}',
                schema: true,
                port: 5236,
            }, url => {
                const result = url.match(/^jdbc:dm:\/\/([0-9a-zA-Z_\\.-]+)(:([0-9]+))?\/([0-9a-zA-Z_\\.]+)(.*)/i);
                if (result) {
                    return {
                        host: result[1],
                        port: result[3],
                        databaseName: result[4],
                        urlInfo: result[5],
                    };
                }
            });
        });
    } catch (e) {
        // 20.08.31 之前版本
        BI.config("dec.constant.migration.config.databases", function (items) {
            items.push({
                value: 'dm',
                driver: ['dm.jdbc.driver.DmDriver'],
                url: 'jdbc:dm://{host}:{port}/{database}',
                schema: true,
                port: 5236
            });
            return items;
        })
    }
}());