package com.fr.plugin.platform.db.transfer.dm;

import com.fr.log.FineLoggerFactory;
import com.fr.stable.fun.impl.AbstractDataSourceDriverLoader;

public class DMClassLoaderHandler extends AbstractDataSourceDriverLoader {
    public boolean isInterceptAllowed(String databaseType, String url) {
        if (url.startsWith("jdbc:dm")) {
            FineLoggerFactory.getLogger().info("[dm datasource] The connection has been intercepted.");
            return true;
        }
        return false;
    }

    public ClassLoader getClassLoader() {
        return this.getClass().getClassLoader();
    }
}