package com.fr.plugin.platform.db.transfer.dm;

import com.fr.config.ConfigContext;
import com.fr.config.DefaultConfiguration;
import com.fr.config.Identifier;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

public class DMMigrationConfig extends DefaultConfiguration {

    @Identifier(value = "init")
    private Conf<Boolean> init = Holders.simple(false);

    private static volatile DMMigrationConfig config = null;

    public static DMMigrationConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(DMMigrationConfig.class);
        }
        return config;
    }

    public Boolean isInit() {
        return init.get();
    }

    public void setInit(Boolean init) {
        this.init.set(init);
    }
}